# Drools题目

## 入门

> [!TIP]
>
> demo

- 所购图书总价在100元以下的没有优惠
- 所购图书总价在100到200元的优惠20元
- 所购图书总价在200到300元的优惠50元
- 所购图书总价在300元以上的优惠100元

## 简单

### 简单折扣规则系统

> [!TIP]
>
> demo1

* 当订单金额超过100元时，给予5%折扣
* VIP客户额外获得2%折扣
* 两种折扣可以叠加

### 年龄验证系统

> [!TIP]
>
> demo2

- 场景：年龄限制内容访问控制
- 要求：
  - 18岁以下用户不能访问R级内容
  - 21岁以下用户不能购买酒精类产品
  - 需要处理用户年龄和访问内容类型两个维度

## 中级

### 信用卡申请审批系统

> [!TIP]
>
> demo3

- 场景：自动化信用评估
- 要求：
  - 根据申请人的信用评分、收入和现有负债自动决策
  - 信用评分>700且收入>5万：批准高额度
  - 信用评分600-700：批准中等额度
  - 信用评分<600但收入>10万：批准低额度
  - 其他情况拒绝
- 知识点：复杂条件组合、优先级设置

### 保险费率计算引擎

> [!TIP]
>
> demo4

- 场景：动态保险费定价
- 要求：
  - 基于驾驶记录(事故次数)、车型、地区计算保费
  - 高风险地区保费增加20%
  - 每有一次事故记录保费增加15%
  - 安全车型(有自动刹车等)保费减少10%
  - 多种因素叠加计算

## 高级

### 实时欺诈检测系统

> [!TIP]
>
> demo5

- 场景：支付交易监控
- 要求：
  - 短时间内(如10分钟)同一账户多次大额交易触发警报
  - 交易地点与常用地点距离过远触发警报
  - 异常时间(如凌晨3点)的大额交易
  - 对新账户的首笔大额交易特别关注
  - 使用Drools的流式处理能力

### 动态定价引擎

> [!TIP]
>
> demo6

- 场景：酒店房间实时定价
- 要求：
  - 基于入住率(当前预订/总房间数)动态调整价格
  - 节假日价格自动上浮
  - 临近入住日期剩余房间多时降价
  - 竞争对手价格变化时调整
  - 需要考虑数十条可能互相冲突的规则

## 终极

### 复杂医疗诊断规则系统

- 场景：症状诊断辅助
- 要求：
  - 基于患者症状、病史、检查结果组合推断可能疾病
  - 处理症状之间的关联关系(如发热+咳嗽可能是流感)
  - 处理规则冲突(相同症状可能对应多种疾病)
  - 需要实现规则的可追溯性(能解释为什么得出某个结论)

### 供应链异常处理系统

- 场景：全球物流监控
- 要求：
  - 监控运输延迟、库存异常、需求波动等多维数据
  - 自动触发补货、调货或预警
  - 处理跨国家/地区的海关规则差异
  - 集成天气事件、政治事件等外部数据源
  - 需要处理数千条可能互相影响的业务规则